package com.engine.organization.mapper.post;


import com.engine.organization.entity.TreeData;
import com.engine.organization.entity.postion.po.PostPO;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/13
 * @Version V1.0
 **/
public interface PostMapper {
    /**
     * 获取职务分类根据ID
     *
     * @param id
     * @return
     */
    PostPO getPostByID(@Param("id") long id);

    PostPO getPostByName(@Param("postName") String postName);

    List<PostPO> listByName(@Param("postName") String postName);

    /**
     * 根据ID查询职务分类列表
     * 浏览按钮赋值、展示用
     *
     * @param ids
     * @return
     */
    @MapKey("id")
    List<Map<String, Object>> listPostsByIds(@Param("ids") Collection<Long> ids);

    /**
     * 获取左侧树
     * @return
     */
    ArrayList<TreeData> getTreeData();

    /**
     * 插入职务分类
     *
     * @param postPO
     * @return
     */
    int insertIgnoreNull(PostPO postPO);

    /**
     * 修改，修改所有字段
     *
     * @param postPO
     * @return
     */
    int updatePost(PostPO postPO);

    /**
     * 批量删除职务分类方案
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

    List<PostPO> getPostsByIds(@Param("ids") Collection<Long> ids);
}
